//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1  clrLime
#property indicator_color2  clrRed
#property indicator_color3  clrDarkGreen
#property indicator_color4  clrMaroon
#property indicator_color5  clrDeepSkyBlue
#property indicator_color6  clrDimGray
#property indicator_color7  clrPaleVioletRed
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  2
#property indicator_style6  STYLE_DOT

//
//
//
//
//

//
//
//
//
//

enum enPrices
{
   pr_close,      // Close
   pr_open,       // Open
   pr_high,       // High
   pr_low,        // Low
   pr_median,     // Median
   pr_typical,    // Typical
   pr_weighted,   // Weighted
   pr_average,    // Average (high+low+open+close)/4
   pr_medianb,    // Average median body (open+close)/2
   pr_tbiased,    // Trend biased price
   pr_haclose,    // Heiken ashi close
   pr_haopen ,    // Heiken ashi open
   pr_hahigh,     // Heiken ashi high
   pr_halow,      // Heiken ashi low
   pr_hamedian,   // Heiken ashi median
   pr_hatypical,  // Heiken ashi typical
   pr_haweighted, // Heiken ashi weighted
   pr_haaverage,  // Heiken ashi average
   pr_hamedianb,  // Heiken ashi median body
   pr_hatbiased   // Heiken ashi trend biased price
};

extern ENUM_TIMEFRAMES TimeFrame        = PERIOD_CURRENT;
extern int             BandsPeriod      = 21;
extern enPrices        BandsPrice       = pr_close; // Price to use 
extern int             DeviationsPeriod = 6;
extern bool            Interpolate      = true;

//
//
//
//
//

double bandup[];
double banddn[];
double bandmi[];
double LWUp[],LWDn[];
double RWUp[],RWDn[];
double trend1[];
double trend2[];
string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
// 
//
//
//
//

int init()
{
   IndicatorBuffers(9);
   SetIndexBuffer(0,LWUp); SetIndexStyle(0, DRAW_HISTOGRAM);
	SetIndexBuffer(1,LWDn); SetIndexStyle(1, DRAW_HISTOGRAM);					
	SetIndexBuffer(2,RWUp); SetIndexStyle(2, DRAW_HISTOGRAM);
	SetIndexBuffer(3,RWDn); SetIndexStyle(3, DRAW_HISTOGRAM);	
   SetIndexBuffer(4,bandup);
   SetIndexBuffer(5,bandmi);
   SetIndexBuffer(6,banddn);
	SetIndexBuffer(7,trend1);		
	SetIndexBuffer(8,trend2);	
	
	//
	//
	//
	//
	//
	
   indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame==-99;
   TimeFrame         = MathMax(TimeFrame,_Period);
   
   //
   //
   //
   //
   //	
   
return(0);
}
int deinit() { return(0); }


//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int i,limit,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { LWUp[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //
   
   if (TimeFrame == Period())
   {
     for(i=limit; i>=0; i--) 
     {
        double linreg    = iLinr(getPrice(BandsPrice,Open,Close,High,Low,i),BandsPeriod,i);
        double deviation = iDeviation(linreg,DeviationsPeriod,i);
           if (i>Bars-1)
           {
              bandup[i] = linreg;
              banddn[i] = linreg;
              bandmi[i] = linreg;
              continue;
           }         
         
           //
           //
           //
           //
           //
         
           bandup[i] = bandup[i+1];
           bandmi[i] = bandmi[i+1];
           banddn[i] = banddn[i+1];
           if (linreg>bandup[i+1] || linreg<banddn[i+1])
           {
              bandup[i] = linreg+2.0*deviation;
              banddn[i] = linreg-2.0*deviation;
              bandmi[i] = linreg;
           }
              LWUp[i] = EMPTY_VALUE; LWDn[i] = EMPTY_VALUE;
		        RWUp[i] = EMPTY_VALUE; RWDn[i] = EMPTY_VALUE; 
              trend1[i] = 0;
              trend2[i] = 0;
              if (Close[i]>bandup[i])                      trend1[i] = 1;
              if (Close[i]<banddn[i])                      trend1[i] =-1;
              if (Close[i]<bandup[i]&&Close[i]>bandmi[i])  trend2[i] = 1;
              if (Close[i]>banddn[i]&&Close[i]<bandmi[i])  trend2[i] =-1;
            
              if (trend1[i] == 1) { LWUp[i] = High[i]; LWDn[i] = Low[i]; }
              if (trend1[i] ==-1) { LWDn[i] = High[i]; LWUp[i] = Low[i]; }
              if (trend2[i] == 1) { RWUp[i] = High[i]; RWDn[i] = Low[i]; }
              if (trend2[i] ==-1) { RWDn[i] = High[i]; RWUp[i] = Low[i]; }
   }      
   return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         trend1[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,BandsPeriod,BandsPrice,DeviationsPeriod,7,y);
         trend2[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,BandsPeriod,BandsPrice,DeviationsPeriod,8,y);
         bandup[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,BandsPeriod,BandsPrice,DeviationsPeriod,4,y);
         bandmi[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,BandsPeriod,BandsPrice,DeviationsPeriod,5,y);
         banddn[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,BandsPeriod,BandsPrice,DeviationsPeriod,6,y);
         LWUp[i] = EMPTY_VALUE; LWDn[i] = EMPTY_VALUE;
		   RWUp[i] = EMPTY_VALUE; RWDn[i] = EMPTY_VALUE; 
		   if (trend1[i] == 1) { LWUp[i] = High[i]; LWDn[i] = Low[i]; }
         if (trend1[i] ==-1) { LWDn[i] = High[i]; LWUp[i] = Low[i]; }
         if (trend2[i] == 1) { RWUp[i] = High[i]; RWDn[i] = Low[i]; }
         if (trend2[i] ==-1) { RWDn[i] = High[i]; RWUp[i] = Low[i]; }
         
         //
         //
         //
         //
         //
      
         if (!Interpolate || y==iBarShift(NULL,TimeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,TimeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(int k = 1; k < n; k++)
            {
               bandup[i+k] = bandup[i] + (bandup[i+n] - bandup[i]) * k/n;
               bandmi[i+k] = bandmi[i] + (bandmi[i+n] - bandmi[i]) * k/n;
               banddn[i+k] = banddn[i] + (banddn[i+n] - banddn[i]) * k/n;
            }  	            
	} 
return(0);
}   

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//
//

double workHa[][4];
double getPrice(int price, const double& open[], const double& close[], const double& high[], const double& low[], int i, int instanceNo=0)
{
  if (price>=pr_haclose && price<=pr_hatbiased)
   {
      if (ArrayRange(workHa,0)!= Bars) ArrayResize(workHa,Bars);
         int r = Bars-i-1;
         
         //
         //
         //
         //
         //
         
         double haOpen;
         if (r>0)
                haOpen  = (workHa[r-1][instanceNo+2] + workHa[r-1][instanceNo+3])/2.0;
         else   haOpen  = (open[i]+close[i])/2;
         double haClose = (open[i] + high[i] + low[i] + close[i]) / 4.0;
         double haHigh  = MathMax(high[i], MathMax(haOpen,haClose));
         double haLow   = MathMin(low[i] , MathMin(haOpen,haClose));

         if(haOpen  <haClose) { workHa[r][instanceNo+0] = haLow;  workHa[r][instanceNo+1] = haHigh; } 
         else                 { workHa[r][instanceNo+0] = haHigh; workHa[r][instanceNo+1] = haLow;  } 
                                workHa[r][instanceNo+2] = haOpen;
                                workHa[r][instanceNo+3] = haClose;
         //
         //
         //
         //
         //
         
         switch (price)
         {
            case pr_haclose:     return(haClose);
            case pr_haopen:      return(haOpen);
            case pr_hahigh:      return(haHigh);
            case pr_halow:       return(haLow);
            case pr_hamedian:    return((haHigh+haLow)/2.0);
            case pr_hamedianb:   return((haOpen+haClose)/2.0);
            case pr_hatypical:   return((haHigh+haLow+haClose)/3.0);
            case pr_haweighted:  return((haHigh+haLow+haClose+haClose)/4.0);
            case pr_haaverage:   return((haHigh+haLow+haClose+haOpen)/4.0);
            case pr_hatbiased:
               if (haClose>haOpen)
                     return((haHigh+haClose)/2.0);
               else  return((haLow+haClose)/2.0);        
         }
   }
   
   //
   //
   //
   //
   //
   
   switch (price)
   {
      case pr_close:     return(close[i]);
      case pr_open:      return(open[i]);
      case pr_high:      return(high[i]);
      case pr_low:       return(low[i]);
      case pr_median:    return((high[i]+low[i])/2.0);
      case pr_medianb:   return((open[i]+close[i])/2.0);
      case pr_typical:   return((high[i]+low[i]+close[i])/3.0);
      case pr_weighted:  return((high[i]+low[i]+close[i]+close[i])/4.0);
      case pr_average:   return((high[i]+low[i]+close[i]+open[i])/4.0);
      case pr_tbiased:   
               if (close[i]>open[i])
                     return((high[i]+close[i])/2.0);
               else  return((low[i]+close[i])/2.0);        
   }
   return(0);
}


//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

double workDev[];
double iDeviation(double value, double period, int r, bool isSample=false)
{
   if (ArraySize(workDev)!=Bars) ArrayResize(workDev,Bars); r = Bars-r-1;

   workDev[r] = value; if (r<period) return(0);   
   
   //
   //
   //
   //
   //
   
   double avg = 0; for (int k=0; k<period; k++) avg += workDev[r-k]; avg /= period;
   double sum = 0; for (    k=0; k<period; k++) sum += MathPow((workDev[r-k]-avg),2);
   if (isSample)
         return(MathSqrt(sum/(period-1.0)));
   else  return(MathSqrt(sum/period));
}

//
//
//
//
//

double workLinr[];
double iLinr(double price, double period, int r)
{
   if (ArraySize(workLinr)!= Bars) ArrayResize(workLinr,Bars); r = Bars-r-1;

   //
   //
   //
   //
   //
   
      period = MathMax(period,1);
      workLinr[r] = price;
         if (r<period) return(price);
         double lwmw = period; double lwma = lwmw*price;
         double sma  = price;
         for(int k=1; k<period && (r-k)>=0; k++)
         {
            double weight = period-k;
                   lwmw  += weight;
                   lwma  += weight*workLinr[r-k];  
                   sma   +=        workLinr[r-k];
         }             
   
   return(3.0*lwma/lwmw-2.0*sma/period);
}